-- 
-- FarmingTablet - Appstore
-- 
-- @Interface: 1.4.4.0 1.4.4RC8
-- @Author: kevink98 
-- @Date: 10.06.2017
-- @Version: 1.0.0
-- 
-- @Support: http://ls-modcompany.com
-- @mCompanyInfo: http://mcompany-info.de/
-- 

FarmingTablet_Appstore = {};
FarmingTablet_Appstore_directory = g_currentModDirectory;
FarmingTablet_Appstore_directoryMods = g_modsDirectory;
addModEventListener(FarmingTablet_Appstore);

FarmingTablet_Appstore.version = "1.0.0";
print("   [FarmingTablet - Appstore] load " .. tostring(FarmingTablet_Appstore.version));

function FarmingTablet_Appstore:loadMap()
	local appData = {}; 
	appData.nameOfApp = "Appstore";
	appData.name = "appstore";
	appData.isBuyable = false;
	appData.appCategoryDefault = 1;	
	appData.startWindow = "AppstoreView";
	appData.author = "kevink98";
	appData.version = "1.0";
	appData.priceForAppstore = 0;
	appData.iconImage = createImageOverlay(FarmingTablet_Appstore_directory.."appstore.dds");
	
	appData.modDir = FarmingTablet_Appstore_directory;
	g_currentMission.FarmingTabletModApp.newApp(appData);
	
	FarmingTablet_Appstore.languageXML = loadXMLFile("languageXML", FarmingTablet_Appstore_directory.."languageXML_Tablet.xml","languageXML");
	FarmingTablet_Appstore.langugeShort = Utils.getNoNil(g_languageShort, "en");
	
	g_currentMission.FarmingTabletButton.newCategory("Appstore_PAGE_View");							
	g_currentMission.FarmingTablet.newWindow(appData.name, "AppstoreView","Appstore_PAGE_View",true,true,true);
	local funcUpdate = function() return self:doUpdate_view() end;
	local funcDraw = function() return self:doDraw_view() end;
	g_currentMission.FarmingTablet.setFuncWindows("AppstoreView",funcUpdate,funcDraw)
	
	self.view = {};
	self.view.apps = {};
	self.activeIndex = 1;
	
	self.view.pos = {};
	self.view.pos[1] = {};
	self.view.pos[1].background = {0.085,0.507,0.102,0.197};
	self.view.pos[1].storePic = {0.105,0.58,0.06,0.106};
	self.view.pos[1].price = {0.28, 0.555, 0.021};
	self.view.pos[2] = {};
	self.view.pos[2].background = {0.221,0.507,0.102,0.197};
	self.view.pos[2].storePic = {0.241,0.58,0.06,0.106};
	self.view.pos[2].price = {0.28, 0.555, 0.021};
	self.view.pos[3] = {};
	self.view.pos[3].background = {0.357,0.507,0.102,0.197};
	self.view.pos[3].storePic = {0.377,0.58,0.06,0.106};
	self.view.pos[3].price = {0.28, 0.555, 0.021};
	self.view.pos[4] = {};
	self.view.pos[4].background = {0.493,0.507,0.102,0.197};
	self.view.pos[4].storePic = {0.513,0.58,0.06,0.106};
	self.view.pos[4].price = {0.28, 0.555, 0.021};
	
	self.view.pos[5] = {};
	self.view.pos[5].background = {0.085,0.257,0.102,0.197};
	self.view.pos[5].storePic = {0.105,0.33,0.06,0.106};
	self.view.pos[5].price = {0.28, 0.308, 0.021};
	self.view.pos[6] = {};
	self.view.pos[6].background = {0.221,0.257,0.102,0.197};
	self.view.pos[6].storePic = {0.241,0.33,0.06,0.106};
	self.view.pos[6].price = {0.28, 0.308, 0.021};
	self.view.pos[7] = {};
	self.view.pos[7].background = {0.357,0.257,0.102,0.197};
	self.view.pos[7].storePic = {0.377,0.33,0.06,0.106};
	self.view.pos[7].price = {0.28, 0.308, 0.021};
	self.view.pos[8] = {};
	self.view.pos[8].background = {0.493,0.257,0.102,0.197};
	self.view.pos[8].storePic = {0.513,0.33,0.06,0.106};
	self.view.pos[8].price = {0.28, 0.308, 0.021};
	
	self.view.buttons = {};
	self.view.buttons.view = {};
	
	self.view.buttons.view[1] = g_currentMission.FarmingTabletButton.newButton("view1","Appstore_PAGE_View",0.086,0.508,0.1,0.036,"buttonHover","button");
	self.view.buttons.view[1].onActiveClick = function(...) return self:onActiveClick_view(1,...) end;
	self.view.buttons.view[1].visible = false
	self.view.buttons.view[2] = g_currentMission.FarmingTabletButton.newButton("view3","Appstore_PAGE_View",0.222,0.508,0.1,0.036,"buttonHover","button");
	self.view.buttons.view[2].onActiveClick = function(...) return self:onActiveClick_view(2,...) end;
	self.view.buttons.view[2].visible = false
	self.view.buttons.view[3] = g_currentMission.FarmingTabletButton.newButton("view3","Appstore_PAGE_View",0.358,0.508,0.1,0.036,"buttonHover","button");
	self.view.buttons.view[3].onActiveClick = function(...) return self:onActiveClick_view(3,...) end;
	self.view.buttons.view[3].visible = false
	self.view.buttons.view[4] = g_currentMission.FarmingTabletButton.newButton("view4","Appstore_PAGE_View",0.494,0.508,0.1,0.036,"buttonHover","button");
	self.view.buttons.view[4].onActiveClick = function(...) return self:onActiveClick_view(4,...) end;
	self.view.buttons.view[4].visible = false	
	self.view.buttons.view[5] = g_currentMission.FarmingTabletButton.newButton("view5","Appstore_PAGE_View",0.086,0.258,0.1,0.036,"buttonHover","button");
	self.view.buttons.view[5].onActiveClick = function(...) return self:onActiveClick_view(5,...) end;
	self.view.buttons.view[5].visible = false	
	self.view.buttons.view[6] = g_currentMission.FarmingTabletButton.newButton("view6","Appstore_PAGE_View",0.222,0.258,0.1,0.036,"buttonHover","button");
	self.view.buttons.view[6].onActiveClick = function(...) return self:onActiveClick_view(6,...) end;
	self.view.buttons.view[6].visible = false	
	self.view.buttons.view[7] = g_currentMission.FarmingTabletButton.newButton("view7","Appstore_PAGE_View",0.358,0.258,0.1,0.036,"buttonHover","button");
	self.view.buttons.view[7].onActiveClick = function(...) return self:onActiveClick_view(7,...) end;
	self.view.buttons.view[7].visible = false	
	self.view.buttons.view[8] = g_currentMission.FarmingTabletButton.newButton("view8","Appstore_PAGE_View",0.494,0.258,0.1,0.036,"buttonHover","button");
	self.view.buttons.view[8].onActiveClick = function(...) return self:onActiveClick_view(8,...) end;
	self.view.buttons.view[8].visible = false	
	
	self.view.buttons.viewBuyApp = g_currentMission.FarmingTabletButton.newButton("viewBuyApp","Appstore_PAGE_View",0.658,0.25,0.231,0.038,"buttonHover","button");
	self.view.buttons.viewBuyApp.onActiveClick = function(...) return self:onActiveClick_viewBuyApp(...) end;
	
	FarmingTablet_Appstore.overlays = {};
	FarmingTablet_Appstore.overlays.background = createImageOverlay(FarmingTablet_Appstore_directory.."huds/appstore_background.dds");
	FarmingTablet_Appstore.overlays.appHintergrund = createImageOverlay(FarmingTablet_Appstore_directory.."huds/appHintergrund.dds");
	FarmingTablet_Appstore.overlays.appRahmen = createImageOverlay(FarmingTablet_Appstore_directory.."huds/appRahmen.dds");
	
	g_currentMission.FarmingTablet.addAppToStore = function(...) return FarmingTablet_Appstore:addAppToStore(...) end;
	
	local saveApp = function(...) return self:saveApp(...) end;
	local loadApp = function(...) return self:loadApp(...) end;
	FarmingTablet:saveClientApp(saveApp);
	FarmingTablet:loadClientApp(loadApp);
end;

function FarmingTablet_Appstore:update() end;

function FarmingTablet_Appstore:saveApp(xml, key)
	key = key .. ".Appstore";
	local i = 0;
	for name, app in pairs(g_currentMission.FarmingTablet.APPS) do
		local key_App = key .. string.format(".app(%d)", i);
		setXMLString(xml, key_App .. "#name", name);
		setXMLBool(xml, key_App .. "#isBought", app.isBought);
		if app.backgroundActiveIndex ~= nil then
			setXMLInt(xml, key_App .. "#activeBackground", app.backgroundActiveIndex);
		end;
		i = i + 1;
	end;	
end;

function FarmingTablet_Appstore:loadApp(xml, key)
	key = key .. ".Appstore";
	local i = 0;
	while true do
		local key_App = key .. string.format(".app(%d)", i);
		if not hasXMLProperty(xml, key_App) then
			break;
		end;
		local name = getXMLString(xml, key_App .. "#name");
		local isBought = getXMLBool(xml, key_App .. "#isBought");
		local activeBackground = getXMLInt(xml, key_App .. "#activeBackground");
		if g_currentMission.FarmingTablet.APPS[name] ~= nil then
			g_currentMission.FarmingTablet.APPS[name].isBought = isBought;
			g_currentMission.FarmingTablet.APPS[name].backgroundActiveIndex = activeBackground;
			if isBought and name ~= "appstore" then
				FarmingTablet:addAppToHome(g_currentMission.FarmingTablet.APPS[name].appCategoryDefault,name)
				FarmingTablet_Appstore:removeApp(name)
			end;
		end;
		i = i + 1;
	end;
end;

function FarmingTablet_Appstore:doUpdate_view() end;

function FarmingTablet_Appstore:doDraw_view() 
	renderOverlay(FarmingTablet_Appstore.overlays.background, 0.008,0.0163,1,0.964);
	for i=1, math.min(table.getn(self.view.apps), 8) do
		placeApp = i;
		self:drawPlacecView(i, placeApp);	
		self.view.buttons.view[i].visible = true;
		self:drawButtonText(self.view.buttons.view[i], self.view.apps[placeApp].nameAppstoreButton);
	end;
	
	g_currentMission.FarmingTabletButton.drawButtonByCategory("Appstore_PAGE_View");	
	
	if table.getn(self.view.apps) > 0 then
		if not self.view.buttons.viewBuyApp.visible then
			self.view.buttons.viewBuyApp.visible = true;
		end;
		self:drawButtonText(self.view.buttons.viewBuyApp, self:getXMLlanguage("Appstore_buy"), 0.02);
		
		renderOverlay(FarmingTablet_Appstore.overlays.appRahmen,self.view.pos[self.activeIndex].background[1],self.view.pos[self.activeIndex].background[2],self.view.pos[self.activeIndex].background[3],self.view.pos[self.activeIndex].background[4]);
	
		local app = self.view.apps[self.activeIndex]
		setTextBold(true);
		setTextColor(1,1,1,1);
		renderText(0.661, 0.666, 0.028, tostring(app.nameOfApp));
		renderText(0.745, 0.62, 0.022, self:getXMLlanguage("Appstore_Category"));
		renderText(0.745, 0.56, 0.022, self:getXMLlanguage("Appstore_Author"));
		renderText(0.745, 0.5, 0.022, self:getXMLlanguage("Appstore_Version"));
		setTextBold(false);
		renderOverlay(app.iconImage,0.661, 0.5155, 0.074, 0.1315);
		renderText(0.748, 0.595, 0.022, tostring(FarmingTablet.categorynames[app.appCategoryDefault]));
		renderText(0.748, 0.535, 0.022, app.author);
		renderText(0.748, 0.475, 0.022, app.version);
		
		renderText(0.661, 0.4, 0.018, app.descLine1);
		renderText(0.661, 0.37, 0.018, app.descLine2);
		renderText(0.661, 0.34, 0.018, app.descLine3);
	else
		self.view.buttons.viewBuyApp.visible = false;
	end;				
end;

function FarmingTablet_Appstore:drawPlacecView(pos, placeApp)
	local storePic = self.view.apps[placeApp].iconImage;
	local header = self.view.apps[placeApp].nameOfApp;
	local price = self.view.apps[placeApp].priceForAppstore .." €";
	
	renderOverlay(FarmingTablet_Appstore.overlays.appHintergrund,self.view.pos[pos].background[1],self.view.pos[pos].background[2],self.view.pos[pos].background[3],self.view.pos[pos].background[4]);
	renderOverlay(storePic,self.view.pos[pos].storePic[1],self.view.pos[pos].storePic[2],self.view.pos[pos].storePic[3],self.view.pos[pos].storePic[4]);
	
	local x = (self.view.pos[pos].background[1] + (self.view.pos[pos].background[3] / 2)) - (getTextWidth(self.view.pos[pos].price[3], tostring(price)) / 2);
	setTextColor(0.3843,0.69,0.1176,1);
	renderText(x,self.view.pos[pos].price[2],self.view.pos[pos].price[3], tostring(price)); 		
	setTextColor(0,0,0,1);
end;

function FarmingTablet_Appstore:drawButtonText(button, text, height, factor)
	if button.visible then
		if button.hover then
			setTextColor(0.408,0.412,0.408,1);
		else
			setTextColor(0.3843,0.69,0.1176,1);
		end;
		if height == nil then
			height = 0.02;
		end;
		if factor == nil then
			factor = 1.5;
		end;
		local x = button.posXL + ((button.posXR-button.posXL)/2)-(getTextWidth(height ,text) /2);
		local y = button.posYU +(getTextHeight(height ,text) / factor);
		renderText(x,y, height, text);
		setTextColor(0,0,0,1);
	end;
end;

function FarmingTablet_Appstore:getXMLlanguage(t)
	local i = 0;
	while true do
		local key = string.format("languageXML.text(%d)", i);
		if not hasXMLProperty(FarmingTablet_Appstore.languageXML, key) then			
			break;
		end;
		if getXMLString(FarmingTablet_Appstore.languageXML, key .. "#name") == tostring(t) then
			return getXMLString(FarmingTablet_Appstore.languageXML, key .. "#" .. FarmingTablet_Appstore.langugeShort);
		end;
		i = i + 1;
	end;	
end;

function FarmingTablet_Appstore:addAppToStore(name)
	table.insert(self.view.apps, g_currentMission.FarmingTablet.APPS[name])	
end;

function FarmingTablet_Appstore:onActiveClick_view(index)
	self.activeIndex = index;
end;

function FarmingTablet_Appstore:onActiveClick_viewBuyApp()
	local app = self.view.apps[self.activeIndex]
	app.isBought = true;
	FarmingTablet:addAppToHome(app.appCategoryDefault,app.name)
	g_currentMission.missionStats:changeBalance(-app.priceForAppstore);
	table.remove(self.view.apps, self.activeIndex);
	self.activeIndex = self.activeIndex - 1;
	if self.activeIndex < 1 then
		self.activeIndex = 1;
	end;
	for _, button in pairs(self.view.buttons.view) do
		button.visible = false;
	end;
end;

function FarmingTablet_Appstore:removeApp(name)
	for k, app in pairs(self.view.apps) do
		if app.name == name then
			table.remove(self.view.apps, k);
			break;
		end;
	end;
end;

function FarmingTablet_Appstore:mouseEvent(posX, posY, isDown, isUp, button) end;
function FarmingTablet_Appstore:keyEvent(unicode, sym, modifier, isDown) end;
function FarmingTablet_Appstore:draw() end;
function FarmingTablet_Appstore:delete() end;
function FarmingTablet_Appstore:deleteMap() end; 