-- 
-- FarmingTablet 
-- 
-- @Interface: 1.4.4.0 1.4.4RC8
-- @Author: kevink98 
-- @Date: 10.06.2017
-- @Version: 2.1.0
-- 
-- @Support: http://ls-modcompany.com
-- @mCompanyInfo: http://mcompany-info.de/
-- 

FarmingTablet = {};
FarmingTablet_directory = g_currentModDirectory;
FarmingTablet_directoryMods = g_modsDirectory;
addModEventListener(FarmingTablet);

FarmingTablet.version = "2.1.0";
print("[FarmingTablet] load " .. tostring(FarmingTablet.version));

source(FarmingTablet_directory.."FarmingTabletButton.lua");
source(FarmingTablet_directory.."ModApp.lua");
source(FarmingTablet_directory.."FarmingTabletUtils.lua");
source(FarmingTablet_directory.."FarmingTabletStartEvent.lua");
source(FarmingTablet_directory.."Appstore.lua");

function FarmingTablet:loadMap(xmlFilename)
	if g_currentMission.FarmingTablet == nil then
		g_currentMission.FarmingTablet = {};
		g_currentMission.FarmingTabletButton = {};
		g_currentMission.FarmingTabletModApp = {};
	end;
	FarmingTablet.getAppById = {};
	g_currentMission.FarmingTablet.APPS = {};
	g_currentMission.FarmingTablet.installedApps = 0;
	g_currentMission.FarmingTablet.supportedNumApps = 27;
	g_currentMission.FarmingTablet.posDebug = false;
	
	FarmingTabletUtils:registerUtil();
	
	FarmingTablet.APPS_Positions = {};
	FarmingTablet.APPS_Positions[1] = {
	{0.151,0.64,0.06525,0.116},
	{0.231,0.64,0.06525,0.116},
	{0.311,0.64,0.06525,0.116},
	{0.151,0.52,0.06525,0.116},
	{0.231,0.52,0.06525,0.116},
	{0.311,0.52,0.06525,0.116},
	};
	FarmingTablet.APPS_Positions[2] = {
	{0.41,0.64,0.06525,0.116},
	{0.49,0.64,0.06525,0.116},
	{0.57,0.64,0.06525,0.116},
	{0.41,0.52,0.06525,0.116},
	{0.49,0.52,0.06525,0.116},
	{0.57,0.52,0.06525,0.116},
	};
	FarmingTablet.APPS_Positions[3] = {
	{0.66,0.64,0.06525,0.116},
	{0.74,0.64,0.06525,0.116},
	{0.82,0.64,0.06525,0.116},
	{0.66,0.52,0.06525,0.116},
	{0.74,0.52,0.06525,0.116},
	{0.82,0.52,0.06525,0.116},
	};
	
	FarmingTablet.APPS_posUsed = {};
	for i=1,3 do
		FarmingTablet.APPS_posUsed[i] = {};
		for j=1,(g_currentMission.FarmingTablet.supportedNumApps/3) do
			FarmingTablet.APPS_posUsed[i][j] = false;
		end;
	end;
	FarmingTablet.APPS_toDraw = {};
	
	g_currentMission.FarmingTabletButton.newButton = function(...) return FarmingTabletButton:newButton(...) end;
	g_currentMission.FarmingTabletButton.checkClickByCategory = function(...) return FarmingTabletButton:checkClickByCategory(...) end;
	g_currentMission.FarmingTabletButton.newCategory = function(...) return FarmingTabletButton:newCategory(...) end;
	g_currentMission.FarmingTabletButton.addOverlays = function(...) return FarmingTabletButton:addOverlays(...) end;
	g_currentMission.FarmingTabletButton.getOverlay = function(...) return FarmingTabletButton:getOverlay(...) end;
	g_currentMission.FarmingTabletButton.drawButtonByCategory = function(...) return FarmingTabletButton:drawButtonByCategory(...) end;
	g_currentMission.FarmingTabletModApp.newApp = function(...) return FarmingTabletModApp:newApp(...) end;
	g_currentMission.FarmingTablet.allAppsClose = function(...) return FarmingTablet:allAppsClose(...) end;
	g_currentMission.FarmingTablet.newWindow = function(...) return FarmingTablet:newWindow(...) end;
	g_currentMission.FarmingTablet.setFuncWindows = function(...) return FarmingTablet:setFuncWindows(...) end;
	g_currentMission.FarmingTablet.setWindow = function(...) return FarmingTablet:setWindow(...) end;
	g_currentMission.FarmingTablet.saveApp = function(...) return FarmingTablet:saveApp(...) end;
	g_currentMission.FarmingTablet.loadApp = function(...) return FarmingTablet:loadApp(...) end;
	g_currentMission.FarmingTablet.getStateTablet = function(...) return FarmingTablet:getStateTablet(...) end;
	g_currentMission.FarmingTablet.addNotification = function(...) return FarmingTablet:addNotification(...) end;
	g_currentMission.FarmingTablet.setLoading = function(...) return FarmingTablet:setLoading(...) end;
	g_currentMission.FarmingTablet.getNumActiveWindows = function(...) return FarmingTablet:getNumActiveWindows(...) end;
	g_currentMission.FarmingTablet.addActiveCategories = function(...) return FarmingTablet:addActiveCategories(...) end;
	g_currentMission.FarmingTablet.getAkkuState = function(...) return FarmingTablet:getAkkuState(...) end;
	g_currentMission.FarmingTablet.setLoadingStation = function(...) return FarmingTablet:setLoadingStation(...) end;
	
	FarmingTablet.isServer = g_server ~= nil;
	FarmingTablet.isClient = g_client ~= nil;

	if FarmingTablet.isServer and FarmingTablet.isClient then
		FarmingTablet.isClient = FarmingTablet.isClient and not g_currentMission.connectedToDedicatedServer;
	end;
	
	FarmingTablet.languageXML = loadXMLFile("languageXML", FarmingTablet_directory.."languageXML_Tablet.xml","languageXML");
	FarmingTablet.langugeShort = Utils.getNoNil(g_languageShort, "en");

	FarmingTablet.showTablet = false;
	FarmingTablet.akkuFuel = 648000;
	FarmingTablet.akkuFuelCapacity = 648000;
	FarmingTablet.isLoading = false;
	FarmingTablet.firstRun = true;
	FarmingTablet.serverName = "";
	FarmingTablet.timeToSaveClient = 500;
	FarmingTablet.timerToSaveClient = 300;
	FarmingTablet.loadStart = false;
	FarmingTablet.isInLoadingStation = false;
	
	FarmingTablet.activeOverlay = 1;
	
	FarmingTablet.categorynames = {};
	FarmingTablet.categorynames[1] = FarmingTablet:getXMLlanguage("header01")
	FarmingTablet.categorynames[2] = FarmingTablet:getXMLlanguage("header02")
	FarmingTablet.categorynames[3] = FarmingTablet:getXMLlanguage("header03")
	
	FarmingTablet.tabletRahmen = createImageOverlay(FarmingTablet_directory.."huds/tablet.dds");
	FarmingTablet.getWindowCategory = {};
	FarmingTablet.activateCategory = {};
	FarmingTablet.windows = {};
	FarmingTablet.saveApps = {};
	FarmingTablet.saveClientsApps = {};
	FarmingTablet.loadApps = {};
	FarmingTablet.loadClientsApps = {};
	FarmingTablet.notifications = {};
	FarmingTablet.notificationsById = {};
	FarmingTablet.notificationPopup_timeToShow = 150;
	FarmingTablet.notificationPopup_currentTimeToShow = 150;
	FarmingTablet.notificationPopup_timer = 0;
	FarmingTablet.APPS_chooseBackground = {};
		
	FarmingTablet:newWindow("tabletMain", "Tablet_home","START_PAGE",true)
	FarmingTablet.windows["Tablet_home"].doDraw = function() return FarmingTablet:doDrawTablet_home() end;
	FarmingTablet.windows["Tablet_home"].doUpdate = function() return FarmingTablet:doUpdateTablet_home() end;
	FarmingTablet:newWindow("tabletMain", "Tablet_settings","SETTINGS_PAGE",true)
	FarmingTablet.windows["Tablet_settings"].doDraw = function() return FarmingTablet:doDrawTablet_settings() end;
	FarmingTablet.windows["Tablet_settings"].doUpdate = function() return FarmingTablet:doUpdateTablet_settings() end;
	FarmingTablet:newWindow("tabletMain", "Tablet_notifications","NOTTIFICATIONS_PAGE",true)
	FarmingTablet.windows["Tablet_notifications"].doDraw = function() return FarmingTablet:doDrawTablet_notifications() end;
	FarmingTablet.windows["Tablet_notifications"].doUpdate = function() return FarmingTablet:doUpdateTablet_notifications() end;
	
	FarmingTabletButton:newCategory("START_PAGE");
	FarmingTabletButton:newCategory("SETTINGS_PAGE");
	FarmingTabletButton:newCategory("NOTTIFICATIONS_PAGE");
	
	FarmingTablet.START_PAGE = {}; 
	FarmingTablet.START_PAGE.overlays = {};
	FarmingTablet.START_PAGE.buttons = {};
	FarmingTablet.SETTINGS_PAGE = {};
	FarmingTablet.SETTINGS_PAGE.overlays = {};
	FarmingTablet.SETTINGS_PAGE.buttons = {};
	FarmingTablet.SETTINGS_PAGE.overlayText = {};
	FarmingTablet.SETTINGS_PAGE.overlayText[1] = FarmingTablet:getXMLlanguage("blackL");
	FarmingTablet.SETTINGS_PAGE.overlayText[2] = FarmingTablet:getXMLlanguage("blueL");
	FarmingTablet.SETTINGS_PAGE.overlayText[3] = FarmingTablet:getXMLlanguage("greenL");
	FarmingTablet.SETTINGS_PAGE.overlayText[4] = FarmingTablet:getXMLlanguage("grayL");
	FarmingTablet.SETTINGS_PAGE.overlayText[5] = FarmingTablet:getXMLlanguage("other_1");
	FarmingTablet.SETTINGS_PAGE.overlayText[6] = FarmingTablet:getXMLlanguage("other_2");
	FarmingTablet.SETTINGS_PAGE.overlayText[7] = FarmingTablet:getXMLlanguage("other_3");
	FarmingTablet.SETTINGS_PAGE.overlayText[8] = FarmingTablet:getXMLlanguage("other_4");
	FarmingTablet.SETTINGS_PAGE.overlayText[9] = FarmingTablet:getXMLlanguage("other_5");
	FarmingTablet.SETTINGS_PAGE.overlayText[10] = FarmingTablet:getXMLlanguage("other_6");
	FarmingTablet.SETTINGS_PAGE.overlayText[11] = FarmingTablet:getXMLlanguage("other_7");
	FarmingTablet.SETTINGS_PAGE.overlayText[12] = FarmingTablet:getXMLlanguage("black");
	FarmingTablet.SETTINGS_PAGE.overlayText[13] = FarmingTablet:getXMLlanguage("blue");
	FarmingTablet.SETTINGS_PAGE.overlayText[14] = FarmingTablet:getXMLlanguage("green");
	FarmingTablet.SETTINGS_PAGE.overlayText[15] = FarmingTablet:getXMLlanguage("gray");
	FarmingTablet.SETTINGS_PAGE.overlayText2 = {};
	FarmingTablet.SETTINGS_PAGE.overlayText2[1] = FarmingTablet:getXMLlanguage("blackL");
	FarmingTablet.SETTINGS_PAGE.overlayText2[2] = FarmingTablet:getXMLlanguage("blueL");
	FarmingTablet.SETTINGS_PAGE.overlayText2[3] = FarmingTablet:getXMLlanguage("greenL");
	FarmingTablet.SETTINGS_PAGE.overlayText2[4] = FarmingTablet:getXMLlanguage("grayL");
	FarmingTablet.SETTINGS_PAGE.overlayText2[5] = FarmingTablet:getXMLlanguage("other_1");
	FarmingTablet.SETTINGS_PAGE.overlayText2[6] = FarmingTablet:getXMLlanguage("black");
	FarmingTablet.SETTINGS_PAGE.overlayText2[7] = FarmingTablet:getXMLlanguage("blue");
	FarmingTablet.SETTINGS_PAGE.overlayText2[8] = FarmingTablet:getXMLlanguage("green");
	FarmingTablet.SETTINGS_PAGE.overlayText2[9] = FarmingTablet:getXMLlanguage("gray");
	FarmingTablet.SETTINGS_PAGE.activeAppChoose = 1;
	FarmingTablet.NOTTIFICATIONS_PAGE = {};
	FarmingTablet.NOTTIFICATIONS_PAGE.overlays = {};
	FarmingTablet.NOTTIFICATIONS_PAGE.buttons = {};
	FarmingTablet.NOTTIFICATIONS_PAGE.showPopup = true;
	FarmingTablet.NOTTIFICATIONS_PAGE.showPopupNow = false;
	FarmingTablet.NOTTIFICATIONS_PAGE.notifications = {};
	
	FarmingTablet.START_PAGE.overlays.SCREEN_HOME = {};
	FarmingTablet.START_PAGE.overlays.SCREEN_HOME[1] = createImageOverlay(FarmingTablet_directory.."huds/backgrounds/backScreenHome_1.dds");
	FarmingTablet.START_PAGE.overlays.SCREEN_HOME[2] = createImageOverlay(FarmingTablet_directory.."huds/backgrounds/backScreenHome_2.dds");
	FarmingTablet.START_PAGE.overlays.SCREEN_HOME[3] = createImageOverlay(FarmingTablet_directory.."huds/backgrounds/backScreenHome_3.dds");
	FarmingTablet.START_PAGE.overlays.SCREEN_HOME[4] = createImageOverlay(FarmingTablet_directory.."huds/backgrounds/backScreenHome_4.dds");
	FarmingTablet.START_PAGE.overlays.SCREEN_HOME[5] = createImageOverlay(FarmingTablet_directory.."huds/backgrounds/backScreenHome_5.dds");
	FarmingTablet.START_PAGE.overlays.SCREEN_HOME[6] = createImageOverlay(FarmingTablet_directory.."huds/backgrounds/backScreenHome_6.dds");
	FarmingTablet.START_PAGE.overlays.SCREEN_HOME[7] = createImageOverlay(FarmingTablet_directory.."huds/backgrounds/backScreenHome_7.dds");
	FarmingTablet.START_PAGE.overlays.SCREEN_HOME[8] = createImageOverlay(FarmingTablet_directory.."huds/backgrounds/backScreenHome_8.dds");
	FarmingTablet.START_PAGE.overlays.SCREEN_HOME[9] = createImageOverlay(FarmingTablet_directory.."huds/backgrounds/backScreenHome_9.dds");
	FarmingTablet.START_PAGE.overlays.SCREEN_HOME[10] = createImageOverlay(FarmingTablet_directory.."huds/backgrounds/backScreenHome_10.dds");
	FarmingTablet.START_PAGE.overlays.SCREEN_HOME[11] = createImageOverlay(FarmingTablet_directory.."huds/backgrounds/backScreenHome_11.dds");
	FarmingTablet.START_PAGE.overlays.SCREEN_HOME[12] = createImageOverlay(FarmingTablet_directory.."huds/backgrounds/backScreenHome_12.dds");
	FarmingTablet.START_PAGE.overlays.SCREEN_HOME[13] = createImageOverlay(FarmingTablet_directory.."huds/backgrounds/backScreenHome_13.dds");
	FarmingTablet.START_PAGE.overlays.SCREEN_HOME[14] = createImageOverlay(FarmingTablet_directory.."huds/backgrounds/backScreenHome_14.dds");
	FarmingTablet.START_PAGE.overlays.SCREEN_HOME[15] = createImageOverlay(FarmingTablet_directory.."huds/backgrounds/backScreenHome_15.dds");
	
	FarmingTablet.START_PAGE.overlays.SCREEN_BACK = {};
	FarmingTablet.START_PAGE.overlays.SCREEN_BACK[1] = createImageOverlay(FarmingTablet_directory.."huds/backgrounds/backScreen_1.dds");
	FarmingTablet.START_PAGE.overlays.SCREEN_BACK[2] = createImageOverlay(FarmingTablet_directory.."huds/backgrounds/backScreen_2.dds");
	FarmingTablet.START_PAGE.overlays.SCREEN_BACK[3] = createImageOverlay(FarmingTablet_directory.."huds/backgrounds/backScreen_3.dds");
	FarmingTablet.START_PAGE.overlays.SCREEN_BACK[4] = createImageOverlay(FarmingTablet_directory.."huds/backgrounds/backScreen_4.dds");
	FarmingTablet.START_PAGE.overlays.SCREEN_BACK[5] = createImageOverlay(FarmingTablet_directory.."huds/backgrounds/backScreen_5.dds");
	FarmingTablet.START_PAGE.overlays.SCREEN_BACK[6] = createImageOverlay(FarmingTablet_directory.."huds/backgrounds/backScreen_6.dds");
	FarmingTablet.START_PAGE.overlays.SCREEN_BACK[7] = createImageOverlay(FarmingTablet_directory.."huds/backgrounds/backScreen_7.dds");
	FarmingTablet.START_PAGE.overlays.SCREEN_BACK[8] = createImageOverlay(FarmingTablet_directory.."huds/backgrounds/backScreen_8.dds");
	FarmingTablet.START_PAGE.overlays.SCREEN_BACK[9] = createImageOverlay(FarmingTablet_directory.."huds/backgrounds/backScreen_9.dds");
	
	FarmingTablet.START_PAGE.overlays.SCREEN_GreyAlpha = createImageOverlay(FarmingTablet_directory.."huds/backScreengreyAlpha.dds");
	FarmingTablet.START_PAGE.overlays.AKKU_vis = createImageOverlay(FarmingTablet_directory.."huds/akku.dds");
	FarmingTablet.START_PAGE.overlays.AKKU_b1 = createImageOverlay(FarmingTablet_directory.."huds/akku1.dds");
	FarmingTablet.START_PAGE.overlays.AKKU_b2 = createImageOverlay(FarmingTablet_directory.."huds/akku2.dds");
	FarmingTablet.START_PAGE.overlays.AKKU_b3 = createImageOverlay(FarmingTablet_directory.."huds/akku3.dds");
	FarmingTablet.START_PAGE.overlays.AKKU_b4 = createImageOverlay(FarmingTablet_directory.."huds/akku4.dds");
	FarmingTablet.START_PAGE.overlays.AKKU_red = createImageOverlay(FarmingTablet_directory.."huds/akkuRed.dds");
	FarmingTablet.START_PAGE.overlays.notifications = createImageOverlay(FarmingTablet_directory.."huds/messagesIcon.dds");
	FarmingTablet.START_PAGE.overlays.notificationsHover = createImageOverlay(FarmingTablet_directory.."huds/messageIconKlick.dds");
	FarmingTablet.START_PAGE.overlays.settings = createImageOverlay(FarmingTablet_directory.."huds/settings.dds");
	FarmingTablet.START_PAGE.overlays.settingsHover = createImageOverlay(FarmingTablet_directory.."huds/settingsKlick.dds");
	FarmingTablet.START_PAGE.overlays.shutDown = createImageOverlay(FarmingTablet_directory.."huds/power.dds");
	FarmingTablet.START_PAGE.overlays.shutDownHover = createImageOverlay(FarmingTablet_directory.."huds/powerKlick.dds");
	FarmingTablet.START_PAGE.overlays.background02 = createImageOverlay(FarmingTablet_directory.."huds/background02.dds");
	FarmingTablet.START_PAGE.overlays.background03 = createImageOverlay(FarmingTablet_directory.."huds/background03.dds");
	FarmingTablet.START_PAGE.overlays.background04 = createImageOverlay(FarmingTablet_directory.."huds/background04.dds");
	
	FarmingTablet.START_PAGE.overlays.checkerBoxBig = createImageOverlay(FarmingTablet_directory.."huds/checkerBoxbig.dds");
	FarmingTablet.START_PAGE.overlays.checkerBoxHacken = createImageOverlay(FarmingTablet_directory.."huds/checkerBoxhaken.dds");
	FarmingTablet.START_PAGE.overlays.checkerBoxSmall = createImageOverlay(FarmingTablet_directory.."huds/checkerBoxsmall.dds");
	
	FarmingTablet.START_PAGE.overlays.notificationPopup = createImageOverlay(FarmingTablet_directory.."huds/notification.dds");
	FarmingTablet.START_PAGE.overlays.edit = createImageOverlay(FarmingTablet_directory.."huds/edit.dds");
	FarmingTablet.START_PAGE.overlays.editKlick = createImageOverlay(FarmingTablet_directory.."huds/editKlick.dds");
	
	FarmingTablet.START_PAGE.overlays.button = createImageOverlay(FarmingTablet_directory.."huds/buttons/button.dds");
	FarmingTablet.START_PAGE.overlays.buttonHover = createImageOverlay(FarmingTablet_directory.."huds/buttons/buttonHover.dds");
	FarmingTablet.START_PAGE.overlays.buttonHoverLeft = createImageOverlay(FarmingTablet_directory.."huds/buttons/buttonLeftHover.dds");
	FarmingTablet.START_PAGE.overlays.buttonHoverRight = createImageOverlay(FarmingTablet_directory.."huds/buttons/buttonRightHover.dds");
	FarmingTablet.START_PAGE.overlays.buttonLeft = createImageOverlay(FarmingTablet_directory.."huds/buttons/buttonLeft.dds");
	FarmingTablet.START_PAGE.overlays.buttonRight = createImageOverlay(FarmingTablet_directory.."huds/buttons/buttonRight.dds");
	
	FarmingTablet.START_PAGE.overlays.buttonHoverUp = createImageOverlay(FarmingTablet_directory.."huds/buttons/buttonUpHover.dds");
	FarmingTablet.START_PAGE.overlays.buttonHoverDown = createImageOverlay(FarmingTablet_directory.."huds/buttons/buttonDownHover.dds");
	FarmingTablet.START_PAGE.overlays.buttonUp = createImageOverlay(FarmingTablet_directory.."huds/buttons/buttonUp.dds");
	FarmingTablet.START_PAGE.overlays.buttonDown = createImageOverlay(FarmingTablet_directory.."huds/buttons/buttonDown.dds");
		
	FarmingTablet.START_PAGE.buttons.NOTTIFICATIONS = FarmingTabletButton:newButton("Notification","START_PAGE",0.088,0.28,0.032,0.045,"notificationsHover","notifications");
	FarmingTablet.START_PAGE.buttons.SETTINGS = FarmingTabletButton:newButton("Settings","START_PAGE",0.088,0.21,0.032,0.045,"settingsHover","settings");
	FarmingTablet.START_PAGE.buttons.CLOSE = FarmingTabletButton:newButton("Close","START_PAGE",0.088,0.14,0.032,0.045,"shutDownHover","shutDown");
	
	FarmingTablet.SETTINGS_PAGE.buttons.notificationsPopup = FarmingTabletButton:newButton("notificationsPopup","SETTINGS_PAGE",0.14,0.62,0.035,0.046,"checkerBoxBig","checkerBoxSmall","checkerBoxHacken");
	FarmingTablet.SETTINGS_PAGE.buttons.notificationsPopup.ActivateState = true;
	
	FarmingTablet.SETTINGS_PAGE.buttons.backgroundHomeLower = FarmingTabletButton:newButton("backgroundHomeLower","SETTINGS_PAGE",0.12,0.28,0.035,0.046,"buttonHoverLeft","buttonLeft");
	FarmingTablet.SETTINGS_PAGE.buttons.backgroundHomeHigher = FarmingTabletButton:newButton("backgroundHomeHigher","SETTINGS_PAGE",0.34,0.28,0.035,0.046,"buttonHoverRight","buttonRight");
	FarmingTablet.SETTINGS_PAGE.buttons.chooseAppLower = FarmingTabletButton:newButton("chooseAppLower","SETTINGS_PAGE",0.6,0.34,0.035,0.046,"buttonHoverLeft","buttonLeft");
	FarmingTablet.SETTINGS_PAGE.buttons.chooseAppHigher = FarmingTabletButton:newButton("chooseAppHigher","SETTINGS_PAGE",0.82,0.34,0.035,0.046,"buttonHoverRight","buttonRight");
	FarmingTablet.SETTINGS_PAGE.buttons.backgroundAppLower = FarmingTabletButton:newButton("backgroundAppLower","SETTINGS_PAGE",0.56,0.28,0.035,0.046,"buttonHoverLeft","buttonLeft");
	FarmingTablet.SETTINGS_PAGE.buttons.backgroundAppHigher = FarmingTabletButton:newButton("backgroundAppHigher","SETTINGS_PAGE",0.7,0.28,0.035,0.046,"buttonHoverRight","buttonRight");
	
	FarmingTabletButton:addOverlays(FarmingTablet.START_PAGE.overlays);
	
	local saveApp = function(...) return FarmingTablet:saveMapApp(...) end;
	local loadApp = function(...) return FarmingTablet:loadMapApp(...) end;
	FarmingTablet:saveClientApp(saveApp); 
	FarmingTablet:loadClientApp(loadApp); 
	
	FarmingTablet.windows["Tablet_home"].active = true;
end;

function FarmingTablet:update(dt)
	if g_currentMission.controlledVehicle == nil then
		if InputBinding.isPressed(InputBinding.FTopen1) then
			if InputBinding.isPressed(InputBinding.FTopen2) and not FarmingTablet.showTablet then
				FarmingTablet:openTablet();
			end;
		end;		
		if InputBinding.hasEvent(InputBinding.MENU) and FarmingTablet.showTablet then
			FarmingTablet:closeTablet();
            g_gui:showGui("InGameMenu");
		end;
		if InputBinding.isPressed(InputBinding.FTclose1) then
			if InputBinding.isPressed(InputBinding.FTclose2) and FarmingTablet.showTablet then
				FarmingTablet:closeTablet();
			end;
		end;
	end;
	
	if g_currentMission.environment.currentHour < 10 then
		FarmingTablet.uhr1 = tostring("0"..g_currentMission.environment.currentHour);
	else
		FarmingTablet.uhr1 = tostring(g_currentMission.environment.currentHour);
	end;
	if g_currentMission.environment.currentMinute < 10 then
		FarmingTablet.uhr2 = tostring("0"..g_currentMission.environment.currentMinute);
	else
		FarmingTablet.uhr2 = tostring(g_currentMission.environment.currentMinute);
	end;	
	
	for windowName,_ in pairs(FarmingTablet.windows) do
		if FarmingTablet.windows[windowName] and FarmingTablet.windows[windowName].active then
			FarmingTablet.windows[windowName].doUpdate();
		end;
	end;
	
	if FarmingTablet.isLoading then
		FarmingTablet.akkuFuel = FarmingTablet.akkuFuel + 400;
		if FarmingTablet.akkuFuel > 648000 then
			FarmingTablet.akkuFuel = 648000 
		end;
	elseif FarmingTablet.showTablet then
		FarmingTablet.akkuFuel = FarmingTablet.akkuFuel - 4;
		if FarmingTablet.akkuFuel < 0 then
			FarmingTablet.akkuFuel = 0 
			FarmingTablet:closeTablet();
		end;
	elseif FarmingTablet.NOTTIFICATIONS_PAGE.showPopupNow then
		FarmingTablet.akkuFuel = FarmingTablet.akkuFuel - 2;
		if FarmingTablet.akkuFuel < 0 then
			FarmingTablet.akkuFuel = 0 
			FarmingTablet:closeTablet();
		end;
	end;	
	if FarmingTablet.firstRun then
		if g_server == nil and g_client ~= nil then
			g_client:getServerConnection():sendEvent(FarmingTablet_Start_ClientToServer:new());
		else
			self:loadMapXML();
		end;
		FarmingTablet.firstRun = false;
	end;
	if g_server == nil and g_client ~= nil then
		if FarmingTablet.timerToSaveClient >= FarmingTablet.timeToSaveClient then
			if not FarmingTablet.loadStart then
				self:loadMapXML();	
				FarmingTablet.loadStart = true;
			end;
			self:saveMapXML();
			FarmingTablet.timerToSaveClient = 0;
		else
			FarmingTablet.timerToSaveClient = FarmingTablet.timerToSaveClient + 1;
		end;
	end;
end;

function FarmingTablet:setServerName(name)
	FarmingTablet.serverName = name;
end;

function FarmingTablet:openTablet() 
	if not (FarmingTablet.akkuFuel > 0) then
		FarmingTablet:addNotification(FarmingTablet:getXMLlanguage("akkuEmpty_header"), FarmingTablet:getXMLlanguage("akkuEmpty_line1"), FarmingTablet:getXMLlanguage("akkuEmpty_line2"), nil, false);	
	elseif FarmingTablet.isInLoadingStation then
		FarmingTablet:addNotification(FarmingTablet:getXMLlanguage("noTablet_header"), FarmingTablet:getXMLlanguage("noTablet_line1"), FarmingTablet:getXMLlanguage("noTablet_line2"), nil, false);	
	else
		FarmingTablet.showHelpText = g_currentMission.showHelpText;
		FarmingTablet.isPlayerFrozen = g_currentMission.isPlayerFrozen;
		FarmingTablet.renderTime = g_currentMission.renderTime;
		FarmingTablet.showVehicleSchema = g_currentMission.showVehicleSchema;
		FarmingTablet.ingameMap = g_currentMission.ingameMap.isVisible;
		FarmingTablet.showHudEnv = g_currentMission.showHudEnv;
		FarmingTablet.showWeatherForecast = g_currentMission.showWeatherForecast;
		if g_gui.currentGui ~= nil  then
			g_currentMission.showHelpText = FarmingTablet.showHelpText;
			g_currentMission.isPlayerFrozen = FarmingTablet.isPlayerFrozen;
			g_currentMission.renderTime = FarmingTablet.renderTime;
			g_currentMission.showVehicleSchema = FarmingTablet.showVehicleSchema;
			g_currentMission.ingameMap.isVisible = FarmingTablet.ingameMap;
			g_currentMission.showHudEnv = FarmingTablet.showHudEnv;
			g_currentMission.showWeatherForecast = FarmingTablet.showWeatherForecast;
			InputBinding.setShowMouseCursor(false);
			FarmingTablet.showTablet = false;
			g_gui.currentGui = nil;
		end;
		g_currentMission.showHelpText = false;
		g_currentMission.renderTime = false;
		g_currentMission.showVehicleSchema = false;
		g_currentMission.ingameMap.isVisible = false;
		g_currentMission.showHudEnv = false;
		g_currentMission.showWeatherForecast = false; 
		g_currentMission.isPlayerFrozen = true;
		InputBinding.setShowMouseCursor(true);
		g_gui.currentGui = FarmingTablet;
		FarmingTablet.showTablet = true;
	end;
end;

function FarmingTablet:closeTablet() 
	g_currentMission.showHelpText = FarmingTablet.showHelpText;
	g_currentMission.isPlayerFrozen = FarmingTablet.isPlayerFrozen;
	g_currentMission.renderTime = FarmingTablet.renderTime;
	g_currentMission.showVehicleSchema = FarmingTablet.showVehicleSchema;
	g_currentMission.ingameMap.isVisible = FarmingTablet.ingameMap;
	g_currentMission.showHudEnv = FarmingTablet.showHudEnv;
	g_currentMission.showWeatherForecast = FarmingTablet.showWeatherForecast;
	InputBinding.setShowMouseCursor(false);
	FarmingTablet.showTablet = false;
	g_gui.currentGui = nil;
end;

function FarmingTablet:getStateTablet()
	return FarmingTablet.showTablet;
end;

function FarmingTablet:getAkkuState()
	return FarmingTablet.akkuFuel, FarmingTablet.akkuFuelCapacity;
end;

function FarmingTablet:setLoading(state)
	FarmingTablet.isLoading = state;
	if FarmingTablet.isLoading then
		local update = function(...) return FarmingTablet:updateAkkuLine(...) end;
		FarmingTablet.loadingId = FarmingTablet:addNotification(FarmingTablet:getXMLlanguage("loading_header"), "", "", 0, true, update);	
	elseif not FarmingTablet.isLoading then
		for k, n in pairs(FarmingTablet.notifications) do
			if n.id == FarmingTablet.loadingId then
				table.remove(FarmingTablet.notifications, k);
				break;
			end;
		end;
	end;
end;

function FarmingTablet:setLoadingStation(state)
	FarmingTablet.isInLoadingStation = state;
end;

function FarmingTablet:updateAkkuLine(notification)
	notification.line1 = FarmingTablet:getXMLlanguage("loading_status") .. string.format("%.f %%", (FarmingTablet.akkuFuel / 648000 * 100))
end;

function FarmingTablet:saveApp(func)
	FarmingTablet.saveApps[table.getn(FarmingTablet.saveApps)+1] = func;
end;

function FarmingTablet:saveClientApp(func)
	FarmingTablet.saveClientsApps[table.getn(FarmingTablet.saveClientsApps)+1] = func;
end;

function FarmingTablet:loadApp(func)
	FarmingTablet.loadApps[table.getn(FarmingTablet.loadApps)+1] = func;
end;

function FarmingTablet:loadClientApp(func)
	FarmingTablet.loadClientsApps[table.getn(FarmingTablet.loadClientsApps)+1] = func;
end;

function FarmingTablet:saveMapXML()
	if g_server ~= nil then 		-- is Dedi or SP
		local savegameIndex = g_currentMission.missionInfo.savegameIndex;
		local savegameFolderPath = g_currentMission.missionInfo.savegameDirectory;
		if savegameFolderPath == nil then
			savegameFolderPath = ('%ssavegame%d'):format(getUserProfileAppPath(), savegameIndex);
		end;
		if fileExists(savegameFolderPath .. '/careerSavegame.xml') then
			local xml = loadXMLFile("careerSavegame", savegameFolderPath .. '/careerSavegame.xml',"careerSavegame");
			local key = "careerSavegame.FarmingTablet";
			for k,_ in pairs (FarmingTablet.saveApps) do
				FarmingTablet.saveApps[k](xml, key);
			end;
			if g_client ~= nil then
				for k,_ in pairs (FarmingTablet.saveClientsApps) do
					FarmingTablet.saveClientsApps[k](xml, key);
				end;
			end;
		
			saveXMLFile(xml);
			delete(xml);
		end;
	else							-- is Client in MP Game
		if fileExists(Utils.getFilename("FarmingTablet.xml", getUserProfileAppPath())) then
			local xml = loadXMLFile("FarmingTablet", Utils.getFilename("FarmingTablet.xml", getUserProfileAppPath()),"FarmingTablet");
			local key = "FarmingTablet";
			local i = 0;
			local save = false;
			while true do
				local k = key .. string.format(".server(%d)", i);
				if not hasXMLProperty(xml, k) then
					break;
				end;
				if getXMLString(xml, k .. "#name") == FarmingTablet.serverName then
					for p,_ in pairs (FarmingTablet.saveClientsApps) do
						FarmingTablet.saveClientsApps[p](xml, k);
					end;
					saveXMLFile(xml);
					delete(xml);
					save = true;
					break;
				end;
				i = i + 1;
			end;	
			if not save then
				local k = key .. string.format(".server(%d)", i+1);
				setXMLString(xml, k .. "#name", FarmingTablet.serverName);
				for p,_ in pairs (FarmingTablet.saveClientsApps) do
					FarmingTablet.saveClientsApps[p](xml, k);
				end;
				saveXMLFile(xml);
				delete(xml);
			end;
		else
			local xml = createXMLFile("FarmingTablet", Utils.getFilename("FarmingTablet.xml", getUserProfileAppPath()), "FarmingTablet");
			local key = "FarmingTablet";
			local k = key .. string.format(".server(%d)", 0)
			setXMLString(xml, k .. "#name", FarmingTablet.serverName);
			for p,_ in pairs (FarmingTablet.saveClientsApps) do
				FarmingTablet.saveClientsApps[p](xml, k);
			end;		
			saveXMLFile(xml);
			delete(xml);
		end;
	end;
end;

function FarmingTablet:loadMapXML()
	if g_server ~= nil then 		-- is Dedi or SP
		local savegameIndex = g_currentMission.missionInfo.savegameIndex;
		local savegameFolderPath = g_currentMission.missionInfo.savegameDirectory;
		if savegameFolderPath == nil then
			savegameFolderPath = ('%ssavegame%d'):format(getUserProfileAppPath(), savegameIndex);
		end;
		if fileExists(savegameFolderPath .. '/careerSavegame.xml') then
			local xml = loadXMLFile("careerSavegame", savegameFolderPath .. '/careerSavegame.xml',"careerSavegame");
			local key = "careerSavegame.FarmingTablet";
			if hasXMLProperty(xml, "careerSavegame.FarmingTablet") then
				for k,_ in pairs (FarmingTablet.loadApps) do
					FarmingTablet.loadApps[k](xml, key);
				end;
				if g_client ~= nil then
					for k,_ in pairs (FarmingTablet.loadClientsApps) do
						FarmingTablet.loadClientsApps[k](xml, key);
					end;
				end;			
				delete(xml);
			end;
		end;
	else							-- is Client in MP Game
		local clientXML = Utils.getFilename("FarmingTablet.xml", getUserProfileAppPath());
		if fileExists(clientXML)then
			local xml = loadXMLFile("FarmingTablet", clientXML ,"FarmingTablet");
			local key = "FarmingTablet";
			local i = 0;
			while true do
				local k = key .. string.format(".server(%d)", i)
				if not hasXMLProperty(xml, k) then
					break;
				end;
				if getXMLString(xml, k .. "#name") == FarmingTablet.serverName then
					for p,_ in pairs (FarmingTablet.loadClientsApps) do
						FarmingTablet.loadClientsApps[p](xml, k);
					end;				
					break;
				end;
				i = i + 1;
			end;
			delete(xml);
		end;
	end;
end;

function FarmingTablet:saveMapApp(xml, key)
	setXMLInt(xml, key .. ".akkuFuel", FarmingTablet.akkuFuel);
	setXMLInt(xml, key .. "#activeOverlay", FarmingTablet.activeOverlay);
	setXMLBool(xml, key .. "#showPopup", FarmingTablet.NOTTIFICATIONS_PAGE.showPopup);
end;

function FarmingTablet:loadMapApp(xml, key)
	FarmingTablet.akkuFuel = getXMLInt(xml, key .. ".akkuFuel");
	FarmingTablet.activeOverlay = getXMLInt(xml, key .. "#activeOverlay");
	FarmingTablet.NOTTIFICATIONS_PAGE.showPopup = getXMLBool(xml, key .. "#showPopup");
	
	FarmingTablet.SETTINGS_PAGE.buttons.notificationsPopup.ActivateState = FarmingTablet.NOTTIFICATIONS_PAGE.showPopup;
end;

function FarmingTablet:newWindow(nameApp, name,category,showDetails,isClick,isHover,additionalWindows)
	FarmingTablet.windows[name] = {};
	FarmingTablet.windows[name].active = false;
	if isClick == nil then
		isClick = true;
	end;
	if isHover == nil then
		isHover = true;
	end;
	if nameApp ~= "tabletMain" then
		if g_currentMission.FarmingTablet.APPS[nameApp].useBackgroundsByTablet then
			FarmingTablet.windows[name].useBackgroundsByTablet = true;
			FarmingTablet.windows[name].id = g_currentMission.FarmingTablet.APPS[nameApp].id;
		end;
	end;
	FarmingTablet.windows[name].isClick = isClick;
	FarmingTablet.windows[name].isHover = isHover;
	FarmingTablet.windows[name].showDetails = showDetails or false;
	FarmingTablet.getWindowCategory[name] = category;
end;

function FarmingTablet:setWindow(name,value)
	FarmingTablet.windows[name].active = value;
end;

function FarmingTablet:getNumActiveWindows()
	local i = 0;
	for _, w in pairs(FarmingTablet.windows) do
		if w.active then
			i = i + 1;
		end;
	end;
	return i;
end;

function FarmingTablet:setFuncWindows(name,funcUpdate,funcDraw,funcKeyEvent, drawFirst)
	FarmingTablet.windows[name].doUpdate = funcUpdate;
	FarmingTablet.windows[name].doDraw = funcDraw;
	FarmingTablet.windows[name].drawFirst = drawFirst;
	if funcKeyEvent ~= nil then
		FarmingTablet.windows[name].doKeyEvent = funcKeyEvent;
	end;
end;

function FarmingTablet:addAppToHome(category,name)
	local i = 1;
	while true do
		if not FarmingTablet.APPS_posUsed[category][i] then
			local app = g_currentMission.FarmingTablet.APPS[name]
			app.posUsed = i;
			FarmingTablet.APPS_toDraw[name] = app;
			FarmingTablet.APPS_posUsed[category][i] = true;
			break
		end;
		i = i + 1;
	end;
end;

function FarmingTablet:addActiveCategories(c)
	table.insert(FarmingTablet.activateCategory, c);
end;

function FarmingTablet:mouseEvent(posX, posY, isDown, isUp, button)
	
	if FarmingTablet.showTablet then
		if posX > 0.47 and posX < 0.53 and posY > 0.04 and posY < 0.115 and button == 1 and isDown then
			FarmingTablet:allAppsClose("Tablet_home");
		end;
		for windowName,_ in pairs(FarmingTablet.windows) do
			if FarmingTablet.windows[windowName] and FarmingTablet.windows[windowName].active then
				local category = FarmingTablet.getWindowCategory[windowName]
				if button == 1 and FarmingTablet.windows[windowName].isClick then
					local isClicked = FarmingTabletButton:checkClickByCategory(category,posX,posY,button,isDown);
					if isClicked then
						if table.getn(FarmingTablet.activateCategory) == 0 then
							button = nil;
						end;
					end;
				else 
					if FarmingTablet.windows[windowName].isHover then
						FarmingTabletButton:checkHoverByCategory(category,posX,posY);
					end;
				end;
			end;
		end;
		for _, name in pairs(FarmingTablet.activateCategory) do
			if button == 1 then
				FarmingTabletButton:checkClickByCategory(name,posX,posY,button,isDown);
			else
				FarmingTabletButton:checkHoverByCategory(name,posX,posY);
			end;
		end;
		
		if FarmingTablet.windows["Tablet_home"].active then
			for name,_ in pairs(FarmingTablet.APPS_toDraw) do
				local category = g_currentMission.FarmingTablet.APPS[name].appCategoryDefault;
				local place = g_currentMission.FarmingTablet.APPS[name].posUsed;
				local positions = {};
				positions.xL = FarmingTablet.APPS_Positions[category][place][1]
				positions.xR = FarmingTablet.APPS_Positions[category][place][1] + FarmingTablet.APPS_Positions[category][place][3]
				positions.yU = FarmingTablet.APPS_Positions[category][place][2]
				positions.yO = FarmingTablet.APPS_Positions[category][place][2] + FarmingTablet.APPS_Positions[category][place][4]
				FarmingTabletButton:checkAppClick(posX,posY,button,isDown,positions,g_currentMission.FarmingTablet.APPS[name].startWindow)
			end;
		end;		
	end;
	
	FarmingTablet.activateCategory = {};
	
	if g_currentMission.FarmingTablet.posDebug then
		print(posX.." "..posY);
	end;
	
end;

function FarmingTablet:keyEvent(unicode, sym, modifier, isDown)
	if FarmingTablet.showTablet then
		for windowName,_ in pairs(FarmingTablet.windows) do
			if FarmingTablet.windows[windowName] and FarmingTablet.windows[windowName].active then
				if FarmingTablet.windows[windowName].doKeyEvent ~= nil then			
					FarmingTablet.windows[windowName].doKeyEvent(unicode, sym, modifier, isDown);
				end;
			end;
		end;
	end;
end;

function FarmingTablet:draw() 
	if FarmingTablet.showTablet then
		local showDetails = false;
		
		for windowName,_ in pairs(FarmingTablet.windows) do
			if FarmingTablet.windows[windowName] and FarmingTablet.windows[windowName].active and not FarmingTablet.windows[windowName].drawed then
				if FarmingTablet.windows[windowName].useBackgroundsByTablet then
					local app = FarmingTablet.getAppById[FarmingTablet.windows[windowName].id];
					renderOverlay(FarmingTablet.START_PAGE.overlays.SCREEN_BACK[app.backgroundActiveIndex],0.008,0.0163,1,0.964);
				end;
				if FarmingTablet.windows[windowName].drawFirst ~= nil then
					FarmingTablet.windows[FarmingTablet.windows[windowName].drawFirst].doDraw();
					FarmingTablet.windows[FarmingTablet.windows[windowName].drawFirst].drawed = true;
				end;
				FarmingTablet.windows[windowName].drawed = true;
				FarmingTablet.windows[windowName].doDraw();
				showDetails = FarmingTablet.windows[windowName].showDetails;
			end;
		end;
		for n,_ in pairs(FarmingTablet.windows) do
			FarmingTablet.windows[n].drawed = false;
		end;
		
		if FarmingTablet.windows["Tablet_home"].active or showDetails then --or is activate by App
			setTextColor(1,1,1,1)
			renderText(0.87, 0.838, 0.027, tostring(FarmingTablet.uhr1..":"..FarmingTablet.uhr2));
			if FarmingTablet.akkuFuel < 162000 then
				renderOverlay(FarmingTablet.START_PAGE.overlays.AKKU_red, 0.8, 0.824, 0.045, 0.045);
				renderOverlay(FarmingTablet.START_PAGE.overlays.AKKU_b1, 0.8, 0.824, 0.045, 0.045);
			elseif FarmingTablet.akkuFuel >= 162000 and FarmingTablet.akkuFuel < 324000 then
				renderOverlay(FarmingTablet.START_PAGE.overlays.AKKU_vis, 0.8, 0.824, 0.045, 0.045);
				renderOverlay(FarmingTablet.START_PAGE.overlays.AKKU_b2, 0.8, 0.824, 0.045, 0.045);	
			elseif FarmingTablet.akkuFuel >= 324000 and FarmingTablet.akkuFuel < 486000 then	
				renderOverlay(FarmingTablet.START_PAGE.overlays.AKKU_vis, 0.8, 0.824, 0.045, 0.045);	
				renderOverlay(FarmingTablet.START_PAGE.overlays.AKKU_b3, 0.8, 0.824, 0.045, 0.045);	
			elseif FarmingTablet.akkuFuel >= 324000 and FarmingTablet.akkuFuel <= 648000 then	
				renderOverlay(FarmingTablet.START_PAGE.overlays.AKKU_vis, 0.8, 0.824, 0.045, 0.045);	
				renderOverlay(FarmingTablet.START_PAGE.overlays.AKKU_b4, 0.8, 0.824, 0.045, 0.045);
			end;
			renderText(0.742, 0.838, 0.025, tostring(string.format("%.f", FarmingTablet.akkuFuel/6480))..tostring("%"));
		end;
		renderOverlay(FarmingTablet.tabletRahmen,0.02,0.02,0.96,0.96);
	elseif not FarmingTablet.showTablet then
		if table.getn(FarmingTablet.notifications) > 0 and FarmingTablet.NOTTIFICATIONS_PAGE.showPopup then
			local tim = FarmingTablet.notificationPopup_currentTimeToShow
			if FarmingTablet.notifications[1].noTimeOut then
				tim = FarmingTablet.notificationPopup_timer + 1;
			end;
			if FarmingTablet.notificationPopup_timer >= tim then
				FarmingTablet.notificationPopup_timer = 0;
				table.remove(FarmingTablet.notifications, 1);
				FarmingTablet.NOTTIFICATIONS_PAGE.showPopupNow = false;
			end;
			if table.getn(FarmingTablet.notifications) > 0 then
				local notification = FarmingTablet.notifications[1];
				if notification.update ~= nil then
					notification.update(notification);
				end;
				setTextColor(1,1,1,1)
				
				renderOverlay(FarmingTablet.START_PAGE.overlays.notificationPopup, 0.8, 0.65, 0.18, 0.15);
				renderText(0.8 + 0.009, 0.775, 0.017, FarmingTablet:getXMLlanguage("titel_notification"));
				setTextBold(true);
				renderText(0.8 + 0.02, 0.742, 0.016, notification.nameApp);
				setTextBold(false);
				renderText(0.8 + 0.01, 0.71, 0.014, notification.line1);
				renderText(0.8 + 0.01, 0.68, 0.014, notification.line2);
				setTextColor(0,0,0,1)
				FarmingTablet.notificationPopup_timer = FarmingTablet.notificationPopup_timer + 1;
				FarmingTablet.NOTTIFICATIONS_PAGE.showPopupNow = true;
			end;
		end;
	end;
		
end;

function FarmingTablet:deleteMap() 
	FarmingTablet:delete() 
end;
function FarmingTablet:delete() 
end;

function FarmingTablet:getXMLlanguage(t)
	local i = 0;
	while true do
		local key = string.format("languageXML.text(%d)", i);
		if not hasXMLProperty(FarmingTablet.languageXML, key) then			
			break;
		end;
		if getXMLString(FarmingTablet.languageXML, key .. "#name") == tostring(t) then
			return getXMLString(FarmingTablet.languageXML, key .. "#" .. FarmingTablet.langugeShort);
		end;
		i = i + 1;
	end;	
end;

function FarmingTablet:allAppsClose(window)
	for windowName,_ in pairs(FarmingTablet.windows) do
		FarmingTablet.windows[windowName].active = false;
	end;
	if window then
		FarmingTablet.windows[window].active = true;
	end;
end;

function FarmingTablet:addNotification(nameApp, line1, line2, timeToShow, noTimeOut, update, data)
	local notification = {};
	notification.nameApp = nameApp;
	notification.line1 = line1;
	notification.line2 = line2;
	notification.noTimeOut = noTimeOut or false;
	notification.id = table.getn(FarmingTablet.notifications) + 1;
	notification.update = update;
	table.insert(FarmingTablet.notifications, notification);
	if data ~= nil then
		notification.data = data;
		table.insert(FarmingTablet.NOTTIFICATIONS_PAGE.notifications, notification);
	end;
	FarmingTablet.notificationsById[notification.id] = notification;
	FarmingTablet.notificationPopup_currentTimeToShow = timeToShow or FarmingTablet.notificationPopup_timeToShow;
	return notification.id;
end;

function FarmingTablet:doUpdateTablet_home() 
	
end;

function FarmingTablet:doDrawTablet_home() 
	renderOverlay(FarmingTablet.START_PAGE.overlays.SCREEN_HOME[FarmingTablet.activeOverlay],0.005,0.0163,1,0.964);
	
	setTextColor(1,1,1,1);
	renderText(0.151, 0.792, 0.026, FarmingTablet.categorynames[1]);
	renderText(0.41, 0.792, 0.026, FarmingTablet.categorynames[2]);
	renderText(0.66, 0.792, 0.026, FarmingTablet.categorynames[3]);
	setTextColor(0,0,0,1);
	
	FarmingTabletButton:drawButtonByCategory("START_PAGE");	
	for name,_ in pairs(FarmingTablet.APPS_toDraw) do
		local category = g_currentMission.FarmingTablet.APPS[name].appCategoryDefault;
		local place = g_currentMission.FarmingTablet.APPS[name].posUsed;
		local x,y,xS,yS = FarmingTablet.APPS_Positions[category][place][1],FarmingTablet.APPS_Positions[category][place][2],FarmingTablet.APPS_Positions[category][place][3],FarmingTablet.APPS_Positions[category][place][4]
		renderOverlay(g_currentMission.FarmingTablet.APPS[name].iconImage,x,y,xS,yS);
	end;
end;

function FarmingTablet:doUpdateTablet_notifications() 
	
end;

function FarmingTablet:doDrawTablet_notifications() 
	renderOverlay(FarmingTablet.START_PAGE.overlays.SCREEN_HOME[FarmingTablet.activeOverlay],0.005,0.0163,1,0.964);
	renderOverlay(FarmingTablet.START_PAGE.overlays.SCREEN_GreyAlpha,0.005,0.0163,1,0.964);	
	
	setTextColor(0,0,0,1)
	setTextBold(true)
	renderText(0.086,0.79,0.028,FarmingTablet:getXMLlanguage("notifications"));
	
	local numNot = table.getn(FarmingTablet.NOTTIFICATIONS_PAGE.notifications)
	
	if numNot == 0 then
		local x = 0.5 - getTextWidth(0.03, self:getXMLlanguage("notifications_noNotifictaion")) / 2;
		setTextColor(0,0,0,1);
		renderText(x, 0.5, 0.03, self:getXMLlanguage("notifications_noNotifictaion"))
	else
		for i = 1, numNot do
			if i % 2 == 1 then
				renderOverlay(FarmingTabletButton:getOverlay("background02"), 0.1, 0.72 - ((i - 1) * 0.04), 0.65, 0.04);
			else
				renderOverlay(FarmingTabletButton:getOverlay("background03"), 0.1, 0.72 - ((i - 1) * 0.04), 0.65, 0.04);
			end;
		end;
	end;
end;

function FarmingTablet:doUpdateTablet_settings() 
	
end;

function FarmingTablet:doDrawTablet_settings() 
	renderOverlay(FarmingTablet.START_PAGE.overlays.SCREEN_HOME[FarmingTablet.activeOverlay],0.005,0.0163,1,0.964);
	renderOverlay(FarmingTablet.START_PAGE.overlays.SCREEN_GreyAlpha,0.005,0.0163,1,0.964);	
	
	setTextColor(1,1,1,1)
	setTextBold(true)
	renderText(0.086,0.79,0.028,FarmingTablet:getXMLlanguage("settings"));
	setTextColor(0,0,0,1)
	renderText(0.12,0.72,0.028,FarmingTablet:getXMLlanguage("generalSide"));
	renderText(0.12,0.4,0.028,FarmingTablet:getXMLlanguage("designSide"));
	setTextBold(false)
	renderText(0.2,0.63,0.025,FarmingTablet:getXMLlanguage("showPopup"));
	renderText(0.12,0.35,0.025,FarmingTablet:getXMLlanguage("Head_colorChoose"));
	renderText(0.45,0.35,0.025,FarmingTablet:getXMLlanguage("Head_colorChoose2"));
	renderText(0.46,0.3,0.025,FarmingTablet:getXMLlanguage("Head_colorChoose2_1"));
	renderText(0.2,0.29,0.027,FarmingTablet.SETTINGS_PAGE.overlayText[FarmingTablet.activeOverlay]);
	if g_currentMission.FarmingTablet.installedApps > 0 and FarmingTablet.APPS_chooseBackground[FarmingTablet.SETTINGS_PAGE.activeAppChoose] ~= nil then
		local app = FarmingTablet.getAppById[FarmingTablet.APPS_chooseBackground[FarmingTablet.SETTINGS_PAGE.activeAppChoose].id];
		renderText(0.65,0.35,0.027, app.nameOfApp);
		renderText(0.6,0.29,0.027, FarmingTablet.SETTINGS_PAGE.overlayText2[app.backgroundActiveIndex]);		
		renderOverlay(FarmingTablet.START_PAGE.overlays.SCREEN_BACK[app.backgroundActiveIndex],0.75,0.28,0.1,0.05625);	
	end;
	FarmingTabletButton:drawButtonByCategory("SETTINGS_PAGE");
end;

g_careerScreen.saveSavegame = Utils.appendedFunction(g_careerScreen.saveSavegame, FarmingTablet.saveMapXML);