-- 
-- FarmingTablet - SynchEvents
-- 
-- @Interface: 1.4.4.0 1.4.4RC8
-- @Author: kevink98 
-- @Date: 10.06.2017
-- @Version: 1.0.0
-- 
-- @Support: http://ls-modcompany.com
-- @mCompanyInfo: http://mcompany-info.de/
-- 

FarmingTablet_Start_ClientToServer = {};
FarmingTablet_Start_ClientToServer_mt = Class(FarmingTablet_Start_ClientToServer, Event);
InitEventClass(FarmingTablet_Start_ClientToServer, "FarmingTablet_Start_ClientToServer");
function FarmingTablet_Start_ClientToServer:emptyNew()
    local self = Event:new(FarmingTablet_Start_ClientToServer_mt);
    return self;
end;
function FarmingTablet_Start_ClientToServer:new()
    local self = FarmingTablet_Start_ClientToServer:emptyNew();
    return self;
end;
function FarmingTablet_Start_ClientToServer:readStream(streamId, connection)
	self:run(connection);
end;
function FarmingTablet_Start_ClientToServer:writeStream(streamId, connection)
end;
function FarmingTablet_Start_ClientToServer:run(connection)
	connection:sendEvent(FarmingTablet_Start_ServerToClient:new());
end;

FarmingTablet_Start_ServerToClient = {};
FarmingTablet_Start_ServerToClient_mt = Class(FarmingTablet_Start_ServerToClient, Event);
InitEventClass(FarmingTablet_Start_ServerToClient, "FarmingTablet_Start_ServerToClient");
function FarmingTablet_Start_ServerToClient:emptyNew()
	local self = Event:new(FarmingTablet_Start_ServerToClient_mt);
	return self;
end;
function FarmingTablet_Start_ServerToClient:new()
	local self = FarmingTablet_Start_ServerToClient:emptyNew();
	self.name = g_currentMission.missionDynamicInfo.serverName or "error";
	return self;
end;
function FarmingTablet_Start_ServerToClient:readStream(streamId, connection)
	self.name = streamReadString(streamId);	
	if not connection:getIsServer() then
		g_server:broadcastEvent(FarmingTablet_Start_ServerToClient:new(), false, connection);
	else
		self:run()
	end;
end;
function FarmingTablet_Start_ServerToClient:writeStream(streamId, connection)
	streamWriteString(streamId, self.name);
end;
function FarmingTablet_Start_ServerToClient:run()
	FarmingTablet:setServerName(self.name);
end;
function FarmingTablet_Start_ServerToClient:sendEvent(name)
	if g_server ~= nil then
		g_server:broadcastEvent(FarmingTablet_Start_ServerToClient:new(g_currentMission.missionDynamicInfo.serverName));
	else
		g_client:getServerConnection():sendEvent(FarmingTablet_Start_ServerToClient:new())
	end;
end;